#!/usr/bin/perl
# vs-lib.pl
do '../web-lib.pl';
&init_config("lvs");

$IPVSADM="/sbin/ipvsadm";
%schedulernames=("rr"=>$text{"rr"},
		 "wrr"=>$text{"wrr"},
		 "lc"=>$text{"lc"},
		 "wlc"=>$text{"wlc"},
		 );
%fwdnames = ( "Masq"=>"NAT",
			  "Tunnel"=>"Tunnel",
			  "Route"=>"Direct Route"
			);
%protoopt=("TCP"=>"-t",
		"UDP"=>"-u"
);

%fwdopt=("Masq"=>"-m",
		"Tunnel"=>"-i",
		"Route"=>"-g"
);


sub PrettyTable{
	return "\n<table border width=100%>\n @_ \n</table>";
}

sub wtable{
	return "\n<table width=100%>\n @_ \n</table>";
}

sub table{
	return "\n<table>\n @_ \n</table>";
}

sub td{
	return "\n<td>@_</td>";
}

sub ltd{
	return "\n<td align=right>@_</td>";
}

sub hr{
	return "\n<hr>";
}

sub b{
	return "\n<B>@_</B>";
}

sub PrettyTH{
    return "\n<tr $tb> <div align=center>@_</div>\n</tr>";
}

sub PrettyTR{
    return "\n<tr $cb>@_\n</tr>";
}

sub form{
	my $action=shift @_;
	return qq(\n<form method="post" action="$action">\n@_\n</form>);
}

sub a{
	my ($link, $caption)=@_;
	return qq(\n<A href="$link">$caption</A>);
}

sub p{
	return "<p>";
}

sub radio_group{
	my ($name, $items, $defaultitem)=@_;
	my $catstr;
	
	foreach $item (@$items){
		$checked = ($item eq $defaultitem)? "checked" : "";
		$catstr.= qq(\n<input type="radio" name="$name" value="$item" $checked>$item);
	}
	return $catstr;
}

sub textfield{
	my ($name, $size, $value, $max)=@_;
	
	return qq(\n<input type="text" name="$name" value="$value" size="$size" maxlength="$max">);
}

sub popup_menu{
	my ($name, $items, $defaultitem, $labels)=@_;
	my $catstr;
	
	$catstr = qq(<select name=$name>\n);
	foreach $item (@$items){
		$selected = ($item eq $defaultitem)? "selected":"";
		$catstr.= qq(<option $selected value="$item">$labels->{$item}\n);
	}
	
	return $catstr."</select>";
}

sub submit{
	my ($name, $value)=@_;
	return qq(\n<input type="submit" name="$name" value="$value">);
}

sub hidden{
	my ($name, $val)=@_;
	return qq(\n<input type="hidden" name="$name" value="$val">);
}

sub get_lvs_setting{	
	open(IPVS, "$IPVSADM -L -n |") or &error("can't find $IPVSADM");
	
	$_ = <IPVS> or &error( $text{"noipvsmsg"});
	
	$_ = <IPVS>; $_ = <IPVS>;
	
	undef %vsrv;
	my $real_service, $i=0, $j;
	
	while (<IPVS>) {
		if ($_ =~/(\w+)\s+(\d+\.\d+\.\d+\.\d+)\:(\d+|\d+)\s+(\w+)\s+persistent\s+(\d+)/) {
			my $prot = lc $1;
			$real_service = "$2:$3 " . lc $1;
			$vsrv{$i} = { #"real"=>{}, 
			"protocol"=>$1, "address"=>$2, "port"=>$3, "scheduler"=>$4, 
			"persistent"=>$5};	
		}elsif ($_ =~ /(\w+)\s+(\d+\.\d+\.\d+\.\d+)\:(\d+|\d+)\s+(\w+)/) {
			my $prot = lc $1;
			$real_service = "$2:$3 " . lc $1;
			$vsrv{$i} = { #"real"=>{}, 
			"protocol"=>$1, "address"=>$2, "port"=>$3, "scheduler"=>$4};
		}else{
			next;
		}
		$j=0;
		while (<IPVS>){
    		last unless $_ =~/ ->\s+(\d+\.\d+\.\d+\.\d+)\:(\d+)\s+(\w+)\s+(\d+)/;
			$vsrv{$i}->{"real"}->{"$j"} = {"address"=>$1, "forward"=>$3, "weight"=>$4};
			$j++;
		}
		$i++;
		redo;
	}	

	close(IPVS);
	return $logstr;
}

